//---
//	gint:thread:idle - Idle thread interface
//---
#include <gint/thread.h>
#include <gint/std/string.h>

/* define private symbols */
static struct thread thread_idle;
static uint32_t thread_idle_stack[THREAD_IDLE_STACK_SIZE];

//---
//	Internal
//---
/* thread_idle_code(): Code executed by the idle thread */
static void thread_idle_code(void)
{
	while (1) {
		__asm__ volatile ("sleep");
	}
}




//---
//	Module primitive
//---
/* thread_idle_init(): Initialize the idle thread */
void thread_idle_init(void)
{
	memset(&thread_idle, 0x00, sizeof(struct thread));
	thread_idle.context.reg[15] = (uintptr_t)thread_idle_stack;
	thread_idle.context.reg[15] += (THREAD_IDLE_STACK_SIZE << 2);
	thread_idle.context.spc = (uintptr_t)&thread_idle_code;
	thread_idle.context.pr  = (uintptr_t)0xa0000000;
}
void thread_idle_uninit(void)
{
	return;
}




//---
//	User interface
//---
/* thread_idle_get(): Return the idle thread */
struct thread *thread_idle_get(void)
{
	return (&thread_idle);
}
